using System.Collections.Generic;
using CodeHollow.FeedReader;
using SharpRss.Models;

namespace WebSharpRSS.Models
{
    public class GuideItem
    {
        public GuideItem(CategoryModel catModel)
        {
            _categoryModel = catModel;
            Feeds = _categoryModel.Feeds;
        }

        public GuideItem(FeedModel feedModel)
        {
            _feedModel = feedModel;
            Feed = _feedModel.Base;
        }

        private readonly CategoryModel? _categoryModel;
        private readonly FeedModel? _feedModel;
        
        public string Title { get; set; }
        public bool IsSelected { get; set; }
        public string Icon { get; set; }
        
        // Category
        public bool IsExpanded { get; set; }
        public HashSet<FeedModel>? Feeds { get; set; }
        // Feed
        public Feed? Feed { get; set; }

        // Functions
        public async void ItemClick()
        {
            IsExpanded = !IsExpanded;
        }
    }
}